From 8810a54d80f0d62e46d842010e67e145f9470fe5 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 01 2020 05:56:02 +0000
Subject: [PATCH 1142/2232] Move frontmatter content into Includes


---

diff --git a/gen/src/include.rs b/gen/src/include.rs
index b49cf82..ae0b202 100644
--- a/gen/src/include.rs
+++ b/gen/src/include.rs
@@ -1,5 +1,6 @@
-use crate::gen::out::OutFile;
+use crate::gen::out::{Content, OutFile};
 use crate::syntax::{self, IncludeKind};
+use std::ops::{Deref, DerefMut};
 
 /// The complete contents of the "rust/cxx.h" header.
 pub static HEADER: &str = include_str!("include/cxx.h");
@@ -76,6 +77,7 @@ pub struct Includes {
     pub utility: bool,
     pub vector: bool,
     pub basetsd: bool,
+    pub content: Content,
 }
 
 impl Includes {
@@ -102,3 +104,17 @@ impl<'a> From<&'a syntax::Include> for Include {
         }
     }
 }
+
+impl Deref for Includes {
+    type Target = Content;
+
+    fn deref(&self) -> &Self::Target {
+        &self.content
+    }
+}
+
+impl DerefMut for Includes {
+    fn deref_mut(&mut self) -> &mut Self::Target {
+        &mut self.content
+    }
+}
diff --git a/gen/src/out.rs b/gen/src/out.rs
index 9dd4a7d..6d475fc 100644
--- a/gen/src/out.rs
+++ b/gen/src/out.rs
@@ -9,10 +9,10 @@ pub(crate) struct OutFile<'a> {
     pub types: &'a Types<'a>,
     pub include: Includes,
     pub builtin: Builtins,
-    pub front: Content,
     content: RefCell<Content>,
 }
 
+#[derive(Default)]
 pub struct Content {
     bytes: String,
     section_pending: bool,
@@ -26,7 +26,6 @@ impl<'a> OutFile<'a> {
             types,
             include: Includes::new(),
             builtin: Builtins::new(),
-            front: Content::new(),
             content: RefCell::new(Content::new()),
         }
     }
@@ -50,12 +49,12 @@ impl<'a> OutFile<'a> {
     }
 
     pub fn content(&self) -> Vec<u8> {
-        let front = &self.front.bytes;
+        let include = &self.include.content.bytes;
         let content = &self.content.borrow().bytes;
-        let len = front.len() + content.len() + 1;
+        let len = include.len() + content.len() + 1;
         let mut out = String::with_capacity(len);
-        out.push_str(front);
-        if !front.is_empty() && !content.is_empty() {
+        out.push_str(include);
+        if !include.is_empty() && !content.is_empty() {
             out.push('\n');
         }
         out.push_str(content);
@@ -73,13 +72,15 @@ impl Write for Content {
     }
 }
 
+impl PartialEq for Content {
+    fn eq(&self, _other: &Content) -> bool {
+        true
+    }
+}
+
 impl Content {
     fn new() -> Self {
-        Content {
-            bytes: String::new(),
-            section_pending: false,
-            blocks_pending: Vec::new(),
-        }
+        Content::default()
     }
 
     pub fn next_section(&mut self) {
diff --git a/gen/src/write.rs b/gen/src/write.rs
index 9a1331e..f32cb5b 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -1,7 +1,6 @@
-use crate::gen::include::{self, Includes};
 use crate::gen::namespace_organizer::NamespaceEntries;
-use crate::gen::out::{Content, OutFile};
-use crate::gen::Opt;
+use crate::gen::out::OutFile;
+use crate::gen::{include, Opt};
 use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::symbol::Symbol;
 use crate::syntax::{
@@ -16,7 +15,7 @@ pub(super) fn gen<'a>(apis: &[Api], types: &'a Types, opt: &Opt, header: bool) -
     let out = &mut out_file;
 
     if header {
-        writeln!(out.front, "#pragma once");
+        writeln!(out.include, "#pragma once");
     }
 
     out.include.extend(&opt.include);
@@ -41,7 +40,7 @@ pub(super) fn gen<'a>(apis: &[Api], types: &'a Types, opt: &Opt, header: bool) -
         write_generic_instantiations(out);
     }
 
-    write_includes(&mut out.front, &out.include);
+    write_includes(out);
 
     out_file
 }
@@ -248,7 +247,10 @@ fn pick_includes_and_builtins(out: &mut OutFile, apis: &[Api]) {
     }
 }
 
-fn write_includes(out: &mut Content, include: &Includes) {
+fn write_includes(out: &mut OutFile) {
+    let include = &mut out.include;
+    let out = &mut include.content;
+
     for include in &include.custom {
         match include.kind {
             IncludeKind::Quoted => {

